Subject: Re: [RFC 0/5] devlink: add an explicit locking API

From: Leon Romanovsky <[email-masked]>
Date: Tue, 2 Nov 2021 19:50:41 +0200

On Tue, Nov 02, 2021 at 08:16:06AM -0700, Jakub Kicinski wrote:
> On Tue, 2 Nov 2021 09:44:17 +0200 Leon Romanovsky wrote:
> > On Mon, Nov 01, 2021 at 01:04:03PM -0700, Edwin Peer wrote:
> > > On Sun, Oct 31, 2021 at 12:23 AM Leon Romanovsky <[email-masked]> wrote:
> > >   
> > > > The average driver author doesn't know locking well and won't be able to
> > > > use devlink reference counting correctly.  
> > > 
> > > I think this problem largely only exists to the extent that locking
> > > and lifecycle requirements are poorly documented. :P  
> > 
> > I'm talking about general locking concepts that are perfectly documented
> > and still people do crazy things with it. :)
> 
> Yet you seem to be pushing for drivers to implement their own locking.

It wasn't me who suggested to expose devlink internal locks and
reference counting to the drivers. In my implementation, drivers
don't need to manage devlink at all and we will be able internally
understand if lock is needed or not.

At least in theory, working to make it true.

Thanks